import 'package:quiver/core.dart';

class DatabaseException implements Exception {
  final String message;

  DatabaseException(this.message);
}

/// Represent the id in the database
class DatabaseId {
  final String id;

  DatabaseId(this.id);

  @override
  int get hashCode => hashObjects(<String>[id]);

  @override
  bool operator ==(Object other) {
    if (other is DatabaseId) {
      return other.id == id;
    } else if (other is String) {
      return other == id;
    }
    return false;
  }

  @override
  String toString() => 'DatabaseIdInterface("$id")';
}
